Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9385)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 9391)
@@ -37,6 +37,6 @@
     }
 
-    private IHiveDao dao {
-      get { return ServiceLocator.Instance.HiveDao; }
+    private IHiveDtoDao dao {
+      get { return ServiceLocator.Instance.HiveDtoDao; }
     }
 
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9385)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveOperationContext.cs	(revision 9391)
@@ -20,7 +20,12 @@
 #endregion
 
+using System;
+using System.Collections.ObjectModel;
 using System.Diagnostics;
 using System.IO;
 using System.ServiceModel;
+using System.ServiceModel.Channels;
+using System.ServiceModel.Description;
+using System.ServiceModel.Dispatcher;
 using System.Text;
 using HeuristicLab.Services.Hive.DataAccess;
@@ -30,10 +35,5 @@
     public static HiveOperationContext Current {
       get {
-        var context = OperationContext.Current.Extensions.Find<HiveOperationContext>();
-        if (context == null) {
-          context = new HiveOperationContext();
-          OperationContext.Current.Extensions.Add(context);
-        }
-        return context;
+        return OperationContext.Current.Extensions.Find<HiveOperationContext>();
       }
     }
@@ -42,10 +42,38 @@
 
     public void Attach(OperationContext owner) {
-      DataContext = HiveDao.CreateContext();
+      DataContext = new HiveDataContext(Settings.Default.HeuristicLab_Hive_LinqConnectionString);
       //DataContext.Log = new DebugWriter();
     }
 
     public void Detach(OperationContext owner) {
-      // nothing
+      DataContext.Dispose();
+    }
+  }
+
+  public class HiveOperationContextMessageInspector : IDispatchMessageInspector {
+    public object AfterReceiveRequest(ref Message request, IClientChannel channel, InstanceContext instanceContext) {
+      OperationContext.Current.Extensions.Add(new HiveOperationContext());
+      return request.Headers.MessageId;
+    }
+
+    public void BeforeSendReply(ref System.ServiceModel.Channels.Message reply, object correlationState) {
+      OperationContext.Current.Extensions.Remove(HiveOperationContext.Current);
+    }
+  }
+
+  public class HiveOperationContextBehaviorAttribute : Attribute, IServiceBehavior {
+    public void AddBindingParameters(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase,
+      Collection<ServiceEndpoint> endpoints, BindingParameterCollection bindingParameters) {
+    }
+
+    public void ApplyDispatchBehavior(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase) {
+      foreach (ChannelDispatcher cd in serviceHostBase.ChannelDispatchers) {
+        foreach (EndpointDispatcher ed in cd.Endpoints) {
+          ed.DispatchRuntime.MessageInspectors.Add(new HiveOperationContextMessageInspector());
+        }
+      }
+    }
+
+    public void Validate(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase) {
     }
   }
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 9385)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveService.cs	(revision 9391)
@@ -37,5 +37,9 @@
   /// </summary>
   [ServiceBehavior(InstanceContextMode = InstanceContextMode.PerCall, IgnoreExtensionDataObject = true)]
+  [HiveOperationContextBehavior]
   public class HiveService : IHiveService {
+    private IHiveDtoDao dtoDao {
+      get { return ServiceLocator.Instance.HiveDtoDao; }
+    }
     private IHiveDao dao {
       get { return ServiceLocator.Instance.HiveDao; }
@@ -64,10 +68,10 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        task.Id = dao.AddTask(task);
+        task.Id = dtoDao.AddTask(task);
         taskData.TaskId = task.Id;
         taskData.LastUpdate = DateTime.Now;
-        dao.AssignJobToResource(task.Id, resourceIds);
-        dao.AddTaskData(taskData);
-        dao.UpdateTaskState(task.Id, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
+        dtoDao.AssignJobToResource(task.Id, resourceIds);
+        dtoDao.AddTaskData(taskData);
+        dtoDao.UpdateTaskState(task.Id, DA.TaskState.Waiting, null, userManager.CurrentUserId, null);
         return taskData.TaskId;
       }, false, true);
@@ -78,5 +82,5 @@
       return trans.UseTransaction(() => {
         task.ParentTaskId = parentTaskId;
-        return AddTask(task, taskData, dao.GetAssignedResources(parentTaskId).Select(x => x.Id));
+        return AddTask(task, taskData, dtoDao.GetAssignedResources(parentTaskId).Select(x => x.Id));
       }, false, true);
     }
@@ -87,5 +91,5 @@
 
       return trans.UseTransaction(() => {
-        return dao.GetTask(taskId);
+        return dtoDao.GetTask(taskId);
       }, false, false);
     }
@@ -94,5 +98,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var tasks = dao.GetTasks(x => true);
+        var tasks = dtoDao.GetTasks(x => true);
         foreach (var task in tasks)
           author.AuthorizeForTask(task.Id, Permission.Read);
@@ -105,5 +109,5 @@
 
       return trans.UseTransaction(() => {
-        var tasks = dao.GetTasks(x => taskIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
+        var tasks = dtoDao.GetTasks(x => taskIds.Contains(x.TaskId)).Select(x => new LightweightTask(x)).ToArray();
         foreach (var task in tasks)
           author.AuthorizeForTask(task.Id, Permission.Read);
@@ -128,5 +132,5 @@
 
       return trans.UseTransaction(() => {
-        return dao.GetLightweightTasks(task => task.JobId == jobId).ToArray();
+        return dtoDao.GetLightweightTasks(task => task.JobId == jobId).ToArray();
       }, false, true);
     }
@@ -137,5 +141,5 @@
 
       return trans.UseTransaction(() => {
-        return dao.GetLightweightTasksWithoutStateLog(task => task.JobId == jobId).ToArray();
+        return dtoDao.GetLightweightTasksWithoutStateLog(task => task.JobId == jobId).ToArray();
       }, false, false);
     }
@@ -146,5 +150,5 @@
 
       return trans.UseTransaction(() => {
-        return dao.GetTaskData(taskId);
+        return dtoDao.GetTaskData(taskId);
       });
     }
@@ -155,5 +159,5 @@
 
       trans.UseTransaction(() => {
-        dao.UpdateTaskAndPlugins(taskDto);
+        dtoDao.UpdateTaskAndPlugins(taskDto);
       });
     }
@@ -163,11 +167,13 @@
       author.AuthorizeForTask(task.Id, Permission.Full);
 
-      trans.UseTransaction(() => {
-        dao.UpdateTaskAndPlugins(task);
-      });
-
-      trans.UseTransaction(() => {
-        taskData.LastUpdate = DateTime.Now;
-        dao.UpdateTaskData(taskData);
+      // what for?
+      /*trans.UseTransaction(() => {
+        dtoDao.UpdateTaskAndPlugins(task);
+      });*/
+
+      trans.UseTransaction(() => {
+        var data = dao.GetTaskDataByDto(taskData);
+        data.LastUpdate = DateTime.Now;
+        dao.UpdateTaskData(data);
       });
     }
@@ -177,5 +183,5 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        dao.DeleteTask(taskId);
+        dtoDao.DeleteTask(taskId);
       });
     }
@@ -187,6 +193,6 @@
         var tasks = GetChildTasks(parentTaskId, true, false);
         foreach (var task in tasks) {
-          dao.DeleteTask(task.Id);
-          dao.DeleteTaskData(task.Id);
+          dtoDao.DeleteTask(task.Id);
+          dtoDao.DeleteTaskData(task.Id);
         };
       });
@@ -196,20 +202,21 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       author.AuthorizeForTask(taskId, Permission.Full);
-      return trans.UseTransaction(() => {
-        Task task = dao.UpdateTaskState(taskId, DataTransfer.Convert.ToEntity(taskState), slaveId, userId, exception);
-
-        if (task.Command.HasValue && task.Command.Value == Command.Pause && task.State == TaskState.Paused) {
+
+      return trans.UseTransaction(() => {
+        var task = dao.UpdateTaskState(taskId, DT.Convert.ToEntity(taskState), slaveId, userId, exception);
+
+        if (task.Command.HasValue && task.Command.Value == DA.Command.Pause && task.State == DA.TaskState.Paused) {
           task.Command = null;
-        } else if (task.Command.HasValue && task.Command.Value == Command.Abort && task.State == TaskState.Aborted) {
+        } else if (task.Command.HasValue && task.Command.Value == DA.Command.Abort && task.State == DA.TaskState.Aborted) {
           task.Command = null;
-        } else if (task.Command.HasValue && task.Command.Value == Command.Stop && task.State == TaskState.Aborted) {
+        } else if (task.Command.HasValue && task.Command.Value == DA.Command.Stop && task.State == DA.TaskState.Aborted) {
           task.Command = null;
         } else if (taskState == TaskState.Paused && !task.Command.HasValue) {
           // slave paused and uploaded the task (no user-command) -> set waiting.
-          task = dao.UpdateTaskState(taskId, DataTransfer.Convert.ToEntity(TaskState.Waiting), slaveId, userId, exception);
-        }
-
-        dao.UpdateTaskAndPlugins(task);
-        return task;
+          task = dao.UpdateTaskState(taskId, DA.TaskState.Waiting, slaveId, userId, exception);
+        }
+
+        //dtoDao.UpdateTaskAndPluginsDA(task); no idea why this is needed
+        return DT.Convert.ToDto(task);
       });
     }
@@ -217,5 +224,5 @@
     public IEnumerable<Task> GetTasksByResourceId(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      var tasks = trans.UseTransaction(() => dao.GetJobsByResourceId(resourceId));
+      var tasks = trans.UseTransaction(() => dtoDao.GetJobsByResourceId(resourceId));
       foreach (var task in tasks)
         author.AuthorizeForTask(task.Id, Permission.Read);
@@ -229,8 +236,8 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        var task = dao.GetTask(taskId);
+        var task = dtoDao.GetTask(taskId);
         if (task.State == TaskState.Calculating || task.State == TaskState.Transferring) {
           task.Command = Command.Stop;
-          dao.UpdateTask(task);
+          dtoDao.UpdateTask(task);
         } else {
           if (task.State != TaskState.Aborted && task.State != TaskState.Finished && task.State != TaskState.Failed) {
@@ -245,8 +252,8 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        var job = dao.GetTask(taskId);
+        var job = dtoDao.GetTask(taskId);
         if (job.State == TaskState.Calculating || job.State == TaskState.Transferring) {
           job.Command = Command.Pause;
-          dao.UpdateTask(job);
+          dtoDao.UpdateTask(job);
         } else {
           job = UpdateTaskState(taskId, TaskState.Paused, null, null, string.Empty);
@@ -259,7 +266,7 @@
       author.AuthorizeForTask(taskId, Permission.Full);
       trans.UseTransaction(() => {
-        Task task = dao.UpdateTaskState(taskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, string.Empty);
+        Task task = dtoDao.UpdateTaskState(taskId, DA.TaskState.Waiting, null, userManager.CurrentUserId, string.Empty);
         task.Command = null;
-        dao.UpdateTask(task);
+        dtoDao.UpdateTask(task);
       });
     }
@@ -271,10 +278,10 @@
       author.AuthorizeForJob(id, Permission.Read);
       return trans.UseTransaction(() => {
-        var job = dao.GetJobs(x =>
+        var job = dtoDao.GetJobs(x =>
               x.JobId == id
               && (x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0)
             ).FirstOrDefault();
         if (job != null) {
-          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -286,8 +293,8 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var jobs = dao.GetJobs(x => x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0);
+        var jobs = dtoDao.GetJobs(x => x.OwnerUserId == userManager.CurrentUserId || x.JobPermissions.Count(hep => hep.Permission != DA.Permission.NotAllowed && hep.GrantedUserId == userManager.CurrentUserId) > 0);
         foreach (var job in jobs) {
           author.AuthorizeForJob(job.Id, Permission.Read);
-          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -299,7 +306,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       return trans.UseTransaction(() => {
-        var jobs = dao.GetJobs(x => true);
+        var jobs = dtoDao.GetJobs(x => true);
         foreach (var job in jobs) { // no authorization here, since this method is admin-only! (admin is allowed to read all task)
-          job.Permission = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+          job.Permission = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
           job.OwnerUsername = userManager.GetUserById(job.OwnerUserId).UserName;
         }
@@ -313,5 +320,5 @@
         jobDto.OwnerUserId = userManager.CurrentUserId;
         jobDto.DateCreated = DateTime.Now;
-        return dao.AddJob(jobDto);
+        return dtoDao.AddJob(jobDto);
       });
     }
@@ -321,5 +328,5 @@
       author.AuthorizeForJob(jobDto.Id, Permission.Full);
       trans.UseTransaction(() => {
-        dao.UpdateJob(jobDto);
+        dtoDao.UpdateJob(jobDto);
       });
     }
@@ -329,5 +336,5 @@
       author.AuthorizeForJob(jobId, Permission.Full);
       trans.UseTransaction(() => {
-        dao.DeleteJob(jobId); // child task will be deleted by db-trigger
+        dtoDao.DeleteJob(jobId); // child task will be deleted by db-trigger
       });
     }
@@ -338,9 +345,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Job job = dao.GetJob(jobId);
+        Job job = dtoDao.GetJob(jobId);
         if (job == null) throw new FaultException<FaultReason>(new FaultReason("Could not find task with id " + jobId));
-        Permission perm = DT.Convert.ToDto(dao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
+        Permission perm = DT.Convert.ToDto(dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId));
         if (perm != Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DT.Convert.ToEntity(permission));
+        dtoDao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DT.Convert.ToEntity(permission));
       });
     }
@@ -349,9 +356,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Job job = dao.GetJob(jobId);
+        Job job = dtoDao.GetJob(jobId);
         if (job == null) throw new FaultException<FaultReason>(new FaultReason("Could not find task with id " + jobId));
-        DA.Permission perm = dao.GetPermissionForJob(job.Id, userManager.CurrentUserId);
+        DA.Permission perm = dtoDao.GetPermissionForJob(job.Id, userManager.CurrentUserId);
         if (perm != DA.Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permissions for this experiment"));
-        dao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DA.Permission.NotAllowed);
+        dtoDao.SetJobPermission(jobId, userManager.CurrentUserId, grantedUserId, DA.Permission.NotAllowed);
       });
     }
@@ -360,7 +367,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        DA.Permission currentUserPermission = dao.GetPermissionForJob(jobId, userManager.CurrentUserId);
+        DA.Permission currentUserPermission = dtoDao.GetPermissionForJob(jobId, userManager.CurrentUserId);
         if (currentUserPermission != DA.Permission.Full) throw new FaultException<FaultReason>(new FaultReason("Not allowed to list permissions for this experiment"));
-        return dao.GetJobPermissions(x => x.JobId == jobId);
+        return dtoDao.GetJobPermissions(x => x.JobId == jobId);
       });
     }
@@ -379,12 +386,12 @@
 
       trans.UseTransaction(() => {
-        var slave = dao.GetSlave(slaveInfo.Id);
+        var slave = dtoDao.GetSlave(slaveInfo.Id);
 
         if (slave == null) {
-          var healGroup = dao.GetResources(x => x.Name == "HEAL").First();
+          var healGroup = dtoDao.GetResources(x => x.Name == "HEAL").First();
           if (healGroup != null) {
             slaveInfo.ParentResourceId = healGroup.Id;
           }
-          dao.AddSlave(slaveInfo);
+          dtoDao.AddSlave(slaveInfo);
         } else {
           slave.Name = slaveInfo.Name;
@@ -405,5 +412,5 @@
           // don't update those properties: dbSlave.IsAllowedToCalculate, dbSlave.ParentResourceId 
 
-          dao.UpdateSlave(slave);
+          dtoDao.UpdateSlave(slave);
         }
       });
@@ -413,8 +420,8 @@
       authen.AuthenticateForAnyRole(HiveRoles.Slave);
       trans.UseTransaction(() => {
-        var slave = dao.GetSlave(slaveId);
+        var slave = dtoDao.GetSlave(slaveId);
         if (slave != null) {
           slave.SlaveState = SlaveState.Offline;
-          dao.UpdateSlave(slave);
+          dtoDao.UpdateSlave(slave);
         }
       });
@@ -449,5 +456,5 @@
         plugin.DateCreated = DateTime.Now;
 
-        var existing = dao.GetPlugins(x => x.Hash != null).Where(x => x.Hash.SequenceEqual(plugin.Hash));
+        var existing = dtoDao.GetPlugins(x => x.Hash != null).Where(x => x.Hash.SequenceEqual(plugin.Hash));
         if (existing.Count() > 0) {
           // a plugin already exists.
@@ -455,8 +462,8 @@
         }
 
-        Guid pluginId = dao.AddPlugin(plugin);
+        Guid pluginId = dtoDao.AddPlugin(plugin);
         foreach (PluginData pluginData in pluginDatas) {
           pluginData.PluginId = pluginId;
-          dao.AddPluginData(pluginData);
+          dtoDao.AddPluginData(pluginData);
         }
         return pluginId;
@@ -467,5 +474,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return dao.GetPlugin(pluginId);
+        return dtoDao.GetPlugin(pluginId);
       });
     }
@@ -474,5 +481,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return dao.GetPlugins(x => x.Hash == hash).FirstOrDefault();
+        return dtoDao.GetPlugins(x => x.Hash == hash).FirstOrDefault();
       });
     }
@@ -483,5 +490,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       return trans.UseTransaction(() => {
-        return dao.GetPlugins(x => x.Hash != null);
+        return dtoDao.GetPlugins(x => x.Hash != null);
       });
     }
@@ -492,5 +499,5 @@
       return trans.UseTransaction(() => {
         foreach (Guid guid in pluginIds) {
-          pluginDatas.AddRange(dao.GetPluginDatas(x => x.PluginId == guid).ToList());
+          pluginDatas.AddRange(dtoDao.GetPluginDatas(x => x.PluginId == guid).ToList());
         }
         return pluginDatas;
@@ -501,5 +508,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client, HiveRoles.Slave);
       trans.UseTransaction(() => {
-        dao.DeletePlugin(pluginId);
+        dtoDao.DeletePlugin(pluginId);
       });
     }
@@ -510,9 +517,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Resource resource = dao.GetResource(resourceId);
+        Resource resource = dtoDao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
         if (resource.OwnerUserId != userManager.CurrentUserId && !authen.IsInRole(HiveRoles.Administrator)) throw new FaultException<FaultReason>(new FaultReason("Not allowed to grant permission for this resource"));
         foreach (Guid id in grantedUserIds)
-          dao.AddResourcePermission(new ResourcePermission { ResourceId = resourceId, GrantedByUserId = userManager.CurrentUserId, GrantedUserId = id });
+          dtoDao.AddResourcePermission(new ResourcePermission { ResourceId = resourceId, GrantedByUserId = userManager.CurrentUserId, GrantedUserId = id });
       });
     }
@@ -521,9 +528,9 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        Resource resource = dao.GetResource(resourceId);
+        Resource resource = dtoDao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
         if (resource.OwnerUserId != userManager.CurrentUserId && !authen.IsInRole(HiveRoles.Administrator)) throw new FaultException<FaultReason>(new FaultReason("Not allowed to revoke permission for this resource"));
         foreach (Guid id in grantedUserIds)
-          dao.DeleteResourcePermission(resourceId, id);
+          dtoDao.DeleteResourcePermission(resourceId, id);
       });
     }
@@ -532,7 +539,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        Resource resource = dao.GetResource(resourceId);
+        Resource resource = dtoDao.GetResource(resourceId);
         if (resource == null) throw new FaultException<FaultReason>(new FaultReason("Could not find resource with id " + resourceId));
-        return dao.GetResourcePermissions(x => x.ResourceId == resourceId);
+        return dtoDao.GetResourcePermissions(x => x.ResourceId == resourceId);
       });
     }
@@ -541,5 +548,5 @@
     #region Resource Methods
     public IEnumerable<Resource> GetChildResources(Guid resourceId) {
-      return trans.UseTransaction(() => { return dao.GetChildResources(resourceId); });
+      return trans.UseTransaction(() => { return dtoDao.GetChildResources(resourceId); });
     }
     #endregion
@@ -549,5 +556,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Slave);
 
-      Slave s = trans.UseTransaction(() => { return dao.GetSlave(slaveId); });
+      Slave s = trans.UseTransaction(() => { return dtoDao.GetSlave(slaveId); });
       if (s != null) {
         return s.HbInterval;
@@ -559,20 +566,20 @@
     public Guid AddSlave(Slave slave) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => dao.AddSlave(slave));
+      return trans.UseTransaction(() => dtoDao.AddSlave(slave));
     }
 
     public Guid AddSlaveGroup(SlaveGroup slaveGroup) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => dao.AddSlaveGroup(slaveGroup));
+      return trans.UseTransaction(() => dtoDao.AddSlaveGroup(slaveGroup));
     }
 
     public Slave GetSlave(Guid slaveId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => { return dao.GetSlave(slaveId); });
+      return trans.UseTransaction(() => { return dtoDao.GetSlave(slaveId); });
     }
 
     public SlaveGroup GetSlaveGroup(Guid slaveGroupId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
-      return trans.UseTransaction(() => { return dao.GetSlaveGroup(slaveGroupId); });
+      return trans.UseTransaction(() => { return dtoDao.GetSlaveGroup(slaveGroupId); });
     }
 
@@ -580,5 +587,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        return dao.GetSlaves(x => true).Where(x => x.OwnerUserId == null
+        return dtoDao.GetSlaves(x => true).Where(x => x.OwnerUserId == null
                                            || x.OwnerUserId == userManager.CurrentUserId
                                            || userManager.VerifyUser(userManager.CurrentUserId, GetResourcePermissions(x.Id).Select(y => y.GrantedUserId).ToList())
@@ -590,5 +597,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        return dao.GetSlaveGroups(x => true).Where(x => x.OwnerUserId == null
+        return dtoDao.GetSlaveGroups(x => true).Where(x => x.OwnerUserId == null
                                                 || x.OwnerUserId == userManager.CurrentUserId
                                                 || userManager.VerifyUser(userManager.CurrentUserId, GetResourcePermissions(x.Id).Select(y => y.GrantedUserId).ToList())
@@ -600,5 +607,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        dao.UpdateSlave(slave);
+        dtoDao.UpdateSlave(slave);
       });
     }
@@ -607,5 +614,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       trans.UseTransaction(() => {
-        dao.UpdateSlaveGroup(slaveGroup);
+        dtoDao.UpdateSlaveGroup(slaveGroup);
       });
     }
@@ -615,5 +622,5 @@
       author.AuthorizeForResourceAdministration(slaveId);
       trans.UseTransaction(() => {
-        dao.DeleteSlave(slaveId);
+        dtoDao.DeleteSlave(slaveId);
       });
     }
@@ -623,5 +630,5 @@
       author.AuthorizeForResourceAdministration(slaveGroupId);
       trans.UseTransaction(() => {
-        dao.DeleteSlaveGroup(slaveGroupId);
+        dtoDao.DeleteSlaveGroup(slaveGroupId);
       });
     }
@@ -630,7 +637,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
-        var resource = dao.GetResource(resourceId);
+        var resource = dtoDao.GetResource(resourceId);
         resource.ParentResourceId = slaveGroupId;
-        dao.UpdateResource(resource);
+        dtoDao.UpdateResource(resource);
       });
     }
@@ -639,7 +646,7 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator);
       trans.UseTransaction(() => {
-        var resource = dao.GetResource(resourceId);
+        var resource = dtoDao.GetResource(resourceId);
         resource.ParentResourceId = null;
-        dao.UpdateResource(resource);
+        dtoDao.UpdateResource(resource);
       });
     }
@@ -648,5 +655,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       return trans.UseTransaction(() => {
-        var resource = dao.GetResources(x => x.Name == resourceName).FirstOrDefault();
+        var resource = dtoDao.GetResources(x => x.Name == resourceName).FirstOrDefault();
         if (resource != null) {
           return resource.Id;
@@ -662,7 +669,7 @@
       bool cleanup = false;
       trans.UseTransaction(() => {
-        DateTime lastCleanup = dao.GetLastCleanup();
+        DateTime lastCleanup = dtoDao.GetLastCleanup();
         if (force || DateTime.Now - lastCleanup > HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval) {
-          dao.SetLastCleanup(DateTime.Now);
+          dtoDao.SetLastCleanup(DateTime.Now);
           cleanup = true;
         }
@@ -679,5 +686,5 @@
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
       author.AuthorizeForResourceAdministration(downtime.ResourceId);
-      return trans.UseTransaction(() => dao.AddDowntime(downtime));
+      return trans.UseTransaction(() => dtoDao.AddDowntime(downtime));
     }
 
@@ -687,5 +694,5 @@
       // author.AuthorizeForResource(resourceId);
       trans.UseTransaction(() => {
-        dao.DeleteDowntime(downtimeId);
+        dtoDao.DeleteDowntime(downtimeId);
       });
     }
@@ -695,5 +702,5 @@
       author.AuthorizeForResourceAdministration(downtime.ResourceId);
       trans.UseTransaction(() => {
-        dao.UpdateDowntime(downtime);
+        dtoDao.UpdateDowntime(downtime);
       });
     }
@@ -701,5 +708,5 @@
     public IEnumerable<Downtime> GetDowntimesForResource(Guid resourceId) {
       authen.AuthenticateForAnyRole(HiveRoles.Administrator, HiveRoles.Client);
-      return trans.UseTransaction(() => dao.GetDowntimes(x => x.ResourceId == resourceId));
+      return trans.UseTransaction(() => dtoDao.GetDowntimes(x => x.ResourceId == resourceId));
     }
     #endregion
@@ -724,5 +731,5 @@
     #region UserPriority Methods
     public IEnumerable<UserPriority> GetUserPriorities() {
-      return trans.UseTransaction(() => dao.GetUserPriorities(x => true));
+      return trans.UseTransaction(() => dtoDao.GetUserPriorities(x => true));
     }
     #endregion
@@ -730,5 +737,5 @@
     #region Helper Methods
     private IEnumerable<Task> GetChildTasks(Guid? parentTaskId, bool recursive, bool includeParent) {
-      var tasks = new List<Task>(dao.GetTasks(x => parentTaskId == null ? !x.ParentTaskId.HasValue : x.ParentTaskId.Value == parentTaskId));
+      var tasks = new List<Task>(dtoDao.GetTasks(x => parentTaskId == null ? !x.ParentTaskId.HasValue : x.ParentTaskId.Value == parentTaskId));
 
       if (recursive) {
@@ -747,8 +754,8 @@
     #region Statistics Methods
     public IEnumerable<Statistics> GetStatistics() {
-      return trans.UseTransaction(() => { return dao.GetStatistics(x => true); });
+      return trans.UseTransaction(() => { return dtoDao.GetStatistics(x => true); });
     }
     public IEnumerable<Statistics> GetStatisticsForTimePeriod(DateTime from, DateTime to) {
-      return trans.UseTransaction(() => { return dao.GetStatistics(x => x.Timestamp >= from && x.Timestamp <= to); });
+      return trans.UseTransaction(() => { return dtoDao.GetStatistics(x => x.Timestamp >= from && x.Timestamp <= to); });
     }
     #endregion
